#include <GL/glew.h>
#include <GL/freeglut.h>

#include <iostream>

#include "framebuffer.hpp"
#include "shader.hpp"
#include "texture.hpp"
#include "quad.hpp"

#define MIN(X,Y) ((X) < (Y) ? (X) : (Y))
#define MAX(X,Y) ((X) > (Y) ? (X) : (Y))

int windowWidth = 600;
int windowHeight = 600;

int dataSize = 1024;

Quad* fullscreenQuad;
Shader* compareShader;

Framebuffer* buffer;


void init(){

	glewExperimental = GL_TRUE;
	GLenum err = glewInit();
	if (GLEW_OK != err)	{
		std::cerr << "Error: "<< glewGetErrorString(err) << std::endl;
	} else {
		if (GLEW_VERSION_3_3)
		{
			std::cout<< "Driver supports OpenGL 3.3\nDetails:"<< std::endl;
			std::cout << "Using GLEW " << glewGetString(GLEW_VERSION)<< std::endl;
			std::cout << "Vendor: " << glGetString (GL_VENDOR)<< std::endl;
			std::cout << "Renderer: " << glGetString (GL_RENDERER)<< std::endl;
			std::cout << "Version: " << glGetString (GL_VERSION)<< std::endl;
			std::cout << "GLSL: " << glGetString (GL_SHADING_LANGUAGE_VERSION)<< std::endl;
		}
	}
	glGetError();


	fullscreenQuad = new Quad();
	compareShader = new Shader("compute.vert", "compute.frag");

    buffer = new Framebuffer(dataSize, dataSize, 1, true, true);		

    ////
    // TODO: fill buffer with random data. We can also determine the minimum value
    ////
}

void compute(){

	////
	// TODO: render fullscreen quads with compareShader
	// in a loop for each mipmap level
	////
        
    ////
    // TODO: read back 1x1 mip level and write it content to screen
    ////
}

int main(int argc, char* argv[]){
	glutInit(&argc, argv);
	glutInitContextVersion (3, 0);
	glutInitContextFlags (GLUT_CORE_PROFILE | GLUT_DEBUG);
	glutInitDisplayMode(GLUT_RGBA );
	glutInitWindowSize(windowWidth, windowHeight);
	glutCreateWindow("GPGPU 3. labor: glsl");
    glutHideWindow();

	init();
    compute();

	return(0);
}
